/* Copyright (C) 2003, OpenOSX(TM), ALL RIGHTS RESERVED.
   This digital file is free software; OpenOSX(TM)
   gives unlimited permission to copy and/or distribute it,
   with or without modifications, as long as this notice is preserved.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY, to the extent permitted by law; without
   even the implied warranty of MERCHANTABILITY or FITNESS FOR A
   PARTICULAR PURPOSE.
*/

#include <String.h>
#include <ApplicationServices/ApplicationServices.h>
#include "GetPID.h"

int main (int argc, const char * argv[]) {
    int pID = 0;
    Str255 nuString;
    
    printf ("\nOpenOSX appToFront 1.0\n\n");
    printf ("This digital file is free software; OpenOSX(TM)\n");
    printf ("gives unlimited permission to copy and/or distribute it,\n");
    printf ("with or without modifications, as long as this notice is preserved.\n\n");

    printf ("This program is distributed in the hope that it will be useful,\n");
    printf ("but WITHOUT ANY WARRANTY, to the extent permitted by law; without\n");
    printf ("even the implied warranty of MERCHANTABILITY or FITNESS FOR A\n");
    printf ("PARTICULAR PURPOSE.\n\n");
    
    if ( ! ( argv[1] ) ) {
        printf ("Description: appToFront will launch (if not running) and bring the supplied\n");
        printf (" \"appCompletePath\" argument to the foreground and will optionally return the\n");
        printf (" process id.\n\n");
        printf ("Usage:\n > appToFront appCompletePath appName\n\n");
        printf ("Example:\n > appToFront \"/Applications/Utilities/Wish Shell.app\" \"Wish Shell\"\n\n");
        printf ("Note: The \"appName\" argument is optional - you may use this program with just the\n");
        printf (" \"completePath, however \"appName\" is required for if you want this program to\n");
        printf (" return it's associated Process ID.\n\n");
        return -1;
    } else
    {
        printf("Application_PID: %i\n", GetPIDForProcessName(argv[2]));
        if (! (&pID))  {
            printf ("PID not located");
            return -1;
        }
    }
   
    strcat (&nuString, "open '");
    strcat (&nuString, argv[1]);
    strcat (&nuString, "'");
 
    system(&nuString);
    
    return &pID;
}
